function [connected_regions,labels,numregions]= Otsu2 (img)
bw_img=Bw_Otsu(im2double(img));
  %figure;imshow(bw_img);title('Otsu segmentation');
  [descriptors,labels,numregions]=fdesc2(bw_img,400);
   connected_regions=Recognize_pcs(descriptors,labels,numregions);
   title('Otsu segmentation')
end
function bw_img_otsu= Bw_Otsu(img)

%%% Usage:  This function calculates a binary image using Otsu algorithm 
%%% Input:  img2 is a double color image
%%% Output: brown_img_otsu is a binary image for the brown pieces
%%%         baige_img_otsu is a binary image for the baige pieces

%% Detect Green and Red squares using ratios of Red/Green and set them to
% %%% white color
% valr=1;  
% img=filter_background(img,squares,buffer,valr);
%     figure;imshow(img);
% red=img(:,:,1)-img(:,:,2)-img(:,:,3);   
% red=im2bw(red,graythresh(red));
% img(repmat(red,1,1,3))=valr; clear red
% green=img(:,:,2)-img(:,:,1)-img(:,:,3); 
% green=im2bw(green,graythresh(green));
% img(repmat(green,1,1,3))=valr; clear green
% white=img(:,:,3)-img(:,:,1);  
% white=im2bw(white,graythresh(white));
% img(repmat(white,1,1,3))=valr; clear white
%     figure;imshow(img);
%% Binarize the image using Otsu's algorithm
%%%convert image to grayscale

gray_img=rgb2gray(img);
          % figure;imshow(gray_img);
%%%erode gray_img with cross to remove the grid lines of the board

length = 9;
NHOOD = zeros(length);  NHOOD(ceil(length/2), :) = 1;   NHOOD(:, ceil(length/2)) = 1;
w = strel('arbitrary', NHOOD);
gray_img=imerode(imdilate(gray_img,w),w);
            %figure;imshow(gray_img);
bw_img_otsu=im2bw(gray_img,graythresh(gray_img));
            %figure;imshow(bw_img_otsu);

bw_img_otsu=1-bw_img_otsu;
            %figure;imshow(bw_img_otsu);
[L,n]=bwlabel(bw_img_otsu);
            %figure;imshow(label2rgb(L));
         for i=1:n
if numel(L(L==i))<1000
    bw_img_otsu(L==i)=0;
end
         end
  bw_img_otsu=imfill(bw_img_otsu,'holes');
  figure;imshow(bw_img_otsu);title('Otsu')
end