function Connected_regions=Recognize_pcs(descriptors,Label,numregions)

%%% Use: this function recognizes the type of each pieces 
%%% Input: descriptors, label, numregions are the output of fdesc2 
%%% Output: Connected_regions: structure array of length=numregions
%%%         Connected_regions.centroid is the centroid of each region
%%%         Connected_regions.base_xposition is the x coordinate of the
%%%         base point of the region
%%%         Connected_regions.base_yposition is the y coordinate of the
%%%         base point of the region

load DataBase_400pts_new
classes_name{1}='G'; classes_name{2}='Q';    classes_name{3}='B';
classes_name{4}='P';  classes_name{5}='R';    classes_name{6}='K';
STATS=regionprops(Label,'Centroid');
% figure;imshow(label2rgb(Label));
% hold on
% for i=1:numregions
%     [r,c]=find(Label==i);
%     text(round(c(round(length(r)/2))),round(r(round(length(r)/2))),num2str(i),'color','k');
%     hold on
% end
for region=1:numel(descriptors)
    for nn=1:num_classes
        dist=[];
        for j=1:train_pcs(nn)
            dist(j)=norm(descriptors{region}-train_fdsc{nn}(:,j))/norm(descriptors{region});
        end
        [min_dist(nn), best_match(nn)]=min(dist);
        %figure;imshow(train_img{nn,best_match(nn)});
    end
    class_match(region)=find(min_dist==min(min_dist));
%     figure;imshow(train_img{class_match(region),best_match(class_match(region))});
    Connected_regions(region).class=classes_name{class_match(region)};
    Connected_regions(region).centroid=STATS(region).Centroid;
    Connected_regions(region).distance=min(min_dist);
    [ypos,xpos]=find(Label==region);
    [minpos, posind]=max(ypos);
    Connected_regions(region).base_yposition=minpos;
    Connected_regions(region).base_xposition=xpos(posind);
end 
figure;imshow(label2rgb(Label));
hold on
for i=1:numregions
    [r,c]=find(Label==i);
    text(round(c(round(length(r)/2))),round(r(round(length(r)/2))),[classes_name{class_match(i)},',',num2str(i)],'color','k');
    hold on
end
hold on
for i=1:numel(Connected_regions)
    plot(Connected_regions(i).base_xposition,Connected_regions(i).base_yposition,'ko')
    hold on
end
end