function [FD_query_2,Label,n]=fdesc2(binary_query_img,numpts)

%%% Use: This function calculates the fourier descriptors of each
%%% connected region in binary_query_img
%%% Input binary_query_img: is the binary image
%%% numpts the length of the fourier descriptors
%%%Output FD_query_2 is a cell array of length= number of connected regions
%%%in input binay image. each cell contains an array of fourier descriptors
%%%of the corresponding region
%%% Label is the label matrix of binary_query_img
%%% n is the number of connected regions in input binary image
[B,Label,n]=bwboundaries(binary_query_img,'noholes');
% figure
% imshow(binary_query_img);
%  hold on
for region=1:n
boundary=B{region}(:,:);
x=boundary(:,2); y=boundary(:,1);
steps=10;
% for xx=1:length(x)
%     plot(x(xx),y(xx),'g*');
%     hold on
% end
points=round(linspace(1+steps,numel(x),numpts))-1;
%points=0+steps:numel(x)-steps;
% imshow(binary_query_img);
L=numel(points);
for k=1:L
%      hold on
%      plot(x(points(k)+1),y(points(k)+1),'g*');
    ind1(k)=points(k)+1;
    ind2(k)=mod(points(k)-steps,numel(x))+1;
    theta(k)= atan2((y(ind1(k))-y(ind2(k))),(x(ind1(k))-x(ind2(k))))*180/pi;
    phi(k)=(theta(k)-theta(1));
    
    phix(k)=wrapTo360(phi(k));
    shapeless=(ind1(k))*2*pi/numel(x);
    phistar(k)=phix(k)-shapeless*180/pi;
end
%phistar=wrapTo360(phistar);
%% generate graphs
% figure
% stem(theta);
% figure
% stem(phi);
% figure
% stem(phix);
% figure
% stem(phistar)
% figure
% stem(wrapTo180(phistar))
%% Fourier descriptors
phistar=wrapTo180(phistar)*pi/180;
FD_query=abs(fft(phistar));
% FD_query=FD_query/abs(FD_query(2));
FD_query(1)=0;
FD_query=FD_query/max(FD_query);
FD_query_2{region}=FD_query';
end
end

