function [coord]= hough_trans(bw)

%%% This function calculates the linish structures in an image using Hough
%%% transform.
%%% The output coord.x and coord.y has the [x,y] coordinates of the line
%%% pixels

%% Show Hough transform in 2-d
% [H, theta, rho] = hough(bw, 'Theta', -90: 1 :89, 'RhoResolution', 1);
[H, theta, rho] = hough(bw);
% h1 = figure; imagesc(H, 'XData', theta, 'YData', rho);
% axis on, axis normal, hold on;
% colormap(hot);
% colorbar
% xlabel('\theta', 'FontSize', 20), ylabel('\rho', 'FontSize', 20);
% set(gca, 'FontSize', 20);
% hold on
% print(h1,'-dpng','Hough_transform_2d.png')

% Show Hough transform in 3-d
% h2 = figure; mesh(H, 'XData', theta, 'YData', rho);
% colormap(hot);
% xlabel('\theta', 'FontSize', 20), ylabel('\rho', 'FontSize', 20);
% colorbar;
% axis tight;
% set (gca,'Ydir','reverse')
% set(gca, 'FontSize', 20);
% print(h2,'-dpng','Hough_transform_3d.png');
%%
peakNum = 800;
Peaks = houghpeaks(H, peakNum, 'threshold', ceil(0.2*max(H(:))));
thetaPeaks = theta(Peaks(:, 2));
rhoPeaks = rho(Peaks(:,1));
% hold on
% plot(thetaPeaks, rhoPeaks, 'o', 'color', 'Y', 'LineWidth',2);

lines = houghlines(bw, theta, rho, Peaks,...
    'MinLength', 0.03*size(bw,1));
     figure;
     imshow(bw);
     hold on
     for iline = 1:numel(lines)
    xy = [lines(iline).point1; lines(iline).point2];
   plot(xy(:, 1), xy(:, 2), 'y');
   hold on
   coord(iline).x=[]; coord(iline).y=[];
   for xc=min(xy(:,1)):max(xy(:,1))
       coord(iline).x=[coord(iline).x;xc];
       yc=(lines(iline).rho-xc*cos(lines(iline).theta*pi/180))/sin(lines(iline).theta*pi/180);
       coord(iline).y=[coord(iline).y;round(yc)];
   end
     end
end