function [img_r, img_g, fname] = my_preprocess_img(img)

if nargin < 1 || isempty(img)
    [fname, pname] = uigetfile(fullfile('Chess_pictures','*.jpg'));
    % load image with chess board
    img = imread(fullfile(pname, fname));
    % display image
%     figure('Color', 'w');
%     imshow(img, 'InitialMagnification', 'fit');
else
    fname = '';
end

% split image into red and green channels
img_r = img(:, :, 1) - img(:, :, 2) - img(:, :, 3);
img_r = medfilt2(img_r, [5, 5]); % median filter to remove noise
thresh = graythresh(img_r);
img_r = im2bw(img_r, thresh); % binarize red image
img_g = img(:, :, 2) - img(:, :, 1) - img(:, :, 3);
img_g = medfilt2(img_g, [5, 5]); % median filter to remove noise
thresh = graythresh(img_g);
img_g = im2bw(img_g, thresh); % binarize green image

