function square = populate_corners(square, lines)

square.corners = zeros(4, 2); 
for ind1 = 1:2
    theta1 = lines(square.inds(1, ind1)).theta * pi/180;
    rho1 = lines(square.inds(1, ind1)).rho;
    for ind2 = 1:2
        theta2 = lines(square.inds(2, ind2)).theta * pi/180;
        rho2 = lines(square.inds(2, ind2)).rho;
        A = [cos(theta1), sin(theta1);
            cos(theta2), sin(theta2)];
        b = [rho1; rho2];
        x = A \ b;
        square.corners((ind1-1)*2+ind2, :) = x;
        h_corners = plot(x(1), x(2), 'yo');
    end
end
% also get distances between pairs of lines and their angles
square.deltas(1, 1) = sqrt(sum(diff(square.corners([1, 3], :)).^2));
square.deltas(2, 1) = sqrt(sum(diff(square.corners([1, 2], :)).^2));
square.thetas = [lines(square.inds(1, :)).theta;
    lines(square.inds(2, :)).theta];


